<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN"
"http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" lang="en" xml:lang="en">
<head>
<!-- 2021-12-03 Fri 15:43 -->
<meta http-equiv="Content-Type" content="text/html;charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1" />
<title>Nextcloud</title>
<meta name="author" content="dt" />
<meta name="description" content="Knowledge Base - Nextcloud
Header
Header" />
<meta name="generator" content="Org Mode" />
<style>
  #content { max-width: 60em; margin: auto; }
  .title  { text-align: center;
             margin-bottom: .2em; }
  .subtitle { text-align: center;
              font-size: medium;
              font-weight: bold;
              margin-top:0; }
  .todo   { font-family: monospace; color: red; }
  .done   { font-family: monospace; color: green; }
  .priority { font-family: monospace; color: orange; }
  .tag    { background-color: #eee; font-family: monospace;
            padding: 2px; font-size: 80%; font-weight: normal; }
  .timestamp { color: #bebebe; }
  .timestamp-kwd { color: #5f9ea0; }
  .org-right  { margin-left: auto; margin-right: 0px;  text-align: right; }
  .org-left   { margin-left: 0px;  margin-right: auto; text-align: left; }
  .org-center { margin-left: auto; margin-right: auto; text-align: center; }
  .underline { text-decoration: underline; }
  #postamble p, #preamble p { font-size: 90%; margin: .2em; }
  p.verse { margin-left: 3%; }
  pre {
    border: 1px solid #e6e6e6;
    border-radius: 3px;
    background-color: #f2f2f2;
    padding: 8pt;
    font-family: monospace;
    overflow: auto;
    margin: 1.2em;
  }
  pre.src {
    position: relative;
    overflow: auto;
  }
  pre.src:before {
    display: none;
    position: absolute;
    top: -8px;
    right: 12px;
    padding: 3px;
    color: #555;
    background-color: #f2f2f299;
  }
  pre.src:hover:before { display: inline; margin-top: 14px;}
  /* Languages per Org manual */
  pre.src-asymptote:before { content: 'Asymptote'; }
  pre.src-awk:before { content: 'Awk'; }
  pre.src-authinfo::before { content: 'Authinfo'; }
  pre.src-C:before { content: 'C'; }
  /* pre.src-C++ doesn't work in CSS */
  pre.src-clojure:before { content: 'Clojure'; }
  pre.src-css:before { content: 'CSS'; }
  pre.src-D:before { content: 'D'; }
  pre.src-ditaa:before { content: 'ditaa'; }
  pre.src-dot:before { content: 'Graphviz'; }
  pre.src-calc:before { content: 'Emacs Calc'; }
  pre.src-emacs-lisp:before { content: 'Emacs Lisp'; }
  pre.src-fortran:before { content: 'Fortran'; }
  pre.src-gnuplot:before { content: 'gnuplot'; }
  pre.src-haskell:before { content: 'Haskell'; }
  pre.src-hledger:before { content: 'hledger'; }
  pre.src-java:before { content: 'Java'; }
  pre.src-js:before { content: 'Javascript'; }
  pre.src-latex:before { content: 'LaTeX'; }
  pre.src-ledger:before { content: 'Ledger'; }
  pre.src-lisp:before { content: 'Lisp'; }
  pre.src-lilypond:before { content: 'Lilypond'; }
  pre.src-lua:before { content: 'Lua'; }
  pre.src-matlab:before { content: 'MATLAB'; }
  pre.src-mscgen:before { content: 'Mscgen'; }
  pre.src-ocaml:before { content: 'Objective Caml'; }
  pre.src-octave:before { content: 'Octave'; }
  pre.src-org:before { content: 'Org mode'; }
  pre.src-oz:before { content: 'OZ'; }
  pre.src-plantuml:before { content: 'Plantuml'; }
  pre.src-processing:before { content: 'Processing.js'; }
  pre.src-python:before { content: 'Python'; }
  pre.src-R:before { content: 'R'; }
  pre.src-ruby:before { content: 'Ruby'; }
  pre.src-sass:before { content: 'Sass'; }
  pre.src-scheme:before { content: 'Scheme'; }
  pre.src-screen:before { content: 'Gnu Screen'; }
  pre.src-sed:before { content: 'Sed'; }
  pre.src-sh:before { content: 'shell'; }
  pre.src-sql:before { content: 'SQL'; }
  pre.src-sqlite:before { content: 'SQLite'; }
  /* additional languages in org.el's org-babel-load-languages alist */
  pre.src-forth:before { content: 'Forth'; }
  pre.src-io:before { content: 'IO'; }
  pre.src-J:before { content: 'J'; }
  pre.src-makefile:before { content: 'Makefile'; }
  pre.src-maxima:before { content: 'Maxima'; }
  pre.src-perl:before { content: 'Perl'; }
  pre.src-picolisp:before { content: 'Pico Lisp'; }
  pre.src-scala:before { content: 'Scala'; }
  pre.src-shell:before { content: 'Shell Script'; }
  pre.src-ebnf2ps:before { content: 'ebfn2ps'; }
  /* additional language identifiers per "defun org-babel-execute"
       in ob-*.el */
  pre.src-cpp:before  { content: 'C++'; }
  pre.src-abc:before  { content: 'ABC'; }
  pre.src-coq:before  { content: 'Coq'; }
  pre.src-groovy:before  { content: 'Groovy'; }
  /* additional language identifiers from org-babel-shell-names in
     ob-shell.el: ob-shell is the only babel language using a lambda to put
     the execution function name together. */
  pre.src-bash:before  { content: 'bash'; }
  pre.src-csh:before  { content: 'csh'; }
  pre.src-ash:before  { content: 'ash'; }
  pre.src-dash:before  { content: 'dash'; }
  pre.src-ksh:before  { content: 'ksh'; }
  pre.src-mksh:before  { content: 'mksh'; }
  pre.src-posh:before  { content: 'posh'; }
  /* Additional Emacs modes also supported by the LaTeX listings package */
  pre.src-ada:before { content: 'Ada'; }
  pre.src-asm:before { content: 'Assembler'; }
  pre.src-caml:before { content: 'Caml'; }
  pre.src-delphi:before { content: 'Delphi'; }
  pre.src-html:before { content: 'HTML'; }
  pre.src-idl:before { content: 'IDL'; }
  pre.src-mercury:before { content: 'Mercury'; }
  pre.src-metapost:before { content: 'MetaPost'; }
  pre.src-modula-2:before { content: 'Modula-2'; }
  pre.src-pascal:before { content: 'Pascal'; }
  pre.src-ps:before { content: 'PostScript'; }
  pre.src-prolog:before { content: 'Prolog'; }
  pre.src-simula:before { content: 'Simula'; }
  pre.src-tcl:before { content: 'tcl'; }
  pre.src-tex:before { content: 'TeX'; }
  pre.src-plain-tex:before { content: 'Plain TeX'; }
  pre.src-verilog:before { content: 'Verilog'; }
  pre.src-vhdl:before { content: 'VHDL'; }
  pre.src-xml:before { content: 'XML'; }
  pre.src-nxml:before { content: 'XML'; }
  /* add a generic configuration mode; LaTeX export needs an additional
     (add-to-list 'org-latex-listings-langs '(conf " ")) in .emacs */
  pre.src-conf:before { content: 'Configuration File'; }

  table { border-collapse:collapse; }
  caption.t-above { caption-side: top; }
  caption.t-bottom { caption-side: bottom; }
  td, th { vertical-align:top;  }
  th.org-right  { text-align: center;  }
  th.org-left   { text-align: center;   }
  th.org-center { text-align: center; }
  td.org-right  { text-align: right;  }
  td.org-left   { text-align: left;   }
  td.org-center { text-align: center; }
  dt { font-weight: bold; }
  .footpara { display: inline; }
  .footdef  { margin-bottom: 1em; }
  .figure { padding: 1em; }
  .figure p { text-align: center; }
  .equation-container {
    display: table;
    text-align: center;
    width: 100%;
  }
  .equation {
    vertical-align: middle;
  }
  .equation-label {
    display: table-cell;
    text-align: right;
    vertical-align: middle;
  }
  .inlinetask {
    padding: 10px;
    border: 2px solid gray;
    margin: 10px;
    background: #ffffcc;
  }
  #org-div-home-and-up
   { text-align: right; font-size: 70%; white-space: nowrap; }
  textarea { overflow-x: auto; }
  .linenr { font-size: smaller }
  .code-highlighted { background-color: #ffff00; }
  .org-info-js_info-navigation { border-style: none; }
  #org-info-js_console-label
    { font-size: 10px; font-weight: bold; white-space: nowrap; }
  .org-info-js_search-highlight
    { background-color: #ffff00; color: #000000; font-weight: bold; }
  .org-svg { width: 90%; }
</style>
<link rel="stylesheet" type="text/css" href="https://distro.tube/org-html-themes/src/readtheorg_theme/css/htmlize.css"/>
<link rel="stylesheet" type="text/css" href="https://distro.tube/org-html-themes/src/readtheorg_theme/css/readtheorg.css"/>
<script src="httpss://ajax.googleapis.com/ajax/libs/jquery/2.1.3/jquery.min.js"></script>
<script src="httpss://maxcdn.bootstrapcdn.com/bootstrap/3.3.4/js/bootstrap.min.js"></script>
<script type="text/javascript" src="https://distro.tube/org-html-themes/src/lib/js/jquery.stickytableheaders.min.js"></script>
<script type="text/javascript" src="https://distro.tube/org-html-themes/src/readtheorg_theme/js/readtheorg.js"></script>
<link rel="stylesheet" type="text/css" href="https://distro.tube/org-html-themes/src/readtheorg_theme/css/htmlize.css"/>
<link rel="stylesheet" type="text/css" href="https://distro.tube/org-html-themes/src/readtheorg_theme/css/readtheorg.css"/>
<script src="httpss://ajax.googleapis.com/ajax/libs/jquery/2.1.3/jquery.min.js"></script>
<script src="httpss://maxcdn.bootstrapcdn.com/bootstrap/3.3.4/js/bootstrap.min.js"></script>
<script type="text/javascript" src="https://distro.tube/org-html-themes/src/lib/js/jquery.stickytableheaders.min.js"></script>
<script type="text/javascript" src="https://distro.tube/org-html-themes/src/readtheorg_theme/js/readtheorg.js"></script>
<link rel="stylesheet" type="text/css" href="https://distro.tube/org-html-themes/src/readtheorg_theme/css/htmlize.css"/>
<link rel="stylesheet" type="text/css" href="https://distro.tube/org-html-themes/src/readtheorg_theme/css/readtheorg.css"/>
<script src="httpss://ajax.googleapis.com/ajax/libs/jquery/2.1.3/jquery.min.js"></script>
<script src="httpss://maxcdn.bootstrapcdn.com/bootstrap/3.3.4/js/bootstrap.min.js"></script>
<script type="text/javascript" src="https://distro.tube/org-html-themes/src/lib/js/jquery.stickytableheaders.min.js"></script>
<script type="text/javascript" src="https://distro.tube/org-html-themes/src/readtheorg_theme/js/readtheorg.js"></script>
</head>
<body>
<div id="content" class="content">
<h1 class="title">Nextcloud</h1>
<div id="table-of-contents" role="doc-toc">
<h2>Table of Contents</h2>
<div id="text-table-of-contents" role="doc-toc">
<ul>
<li><a href="#org17e9549">Installing Nextcloud on DigitalOcean Ubuntu Server</a>
<ul>
<li><a href="#org48b3ce3">Prerequisites</a>
<ul>
<li><a href="#org7b56951">A DigitalOcean droplet with Ubuntu Server 20.04.  Basic plan is fine for me.</a></li>
<li><a href="#orga61df57">Be sure to update the server: <code>sudo apt update &amp;&amp; sudo apt upgrade</code></a></li>
<li><a href="#org8e05843">A non-root sudo-enabled user and firewall configured on your server.</a></li>
<li><a href="#orgead862f">A domain name pointed to your server.</a></li>
</ul>
</li>
<li><a href="#org1be6bfd">Installing Nextcloud</a>
<ul>
<li><a href="#orgda7f245">sudo snap install nextcloud</a></li>
<li><a href="#org35a756d">snap changes nextcloud</a></li>
</ul>
</li>
<li><a href="#orgb587b9c">Configure Administrative Account</a>
<ul>
<li><a href="#org80db65a">sudo nextcloud.manual-install name password</a></li>
</ul>
</li>
<li><a href="#org07d88ad">Adjusting The Trusted Domains</a>
<ul>
<li><a href="#orgf1f1094">sudo nextcloud.occ config:system:get trusted_domains</a></li>
<li><a href="#org6de770b">sudo nextcloud.occ config:system:set trusted_domains 1 &#x2013;value=example.com</a></li>
</ul>
</li>
<li><a href="#orgca0fe87">SSL and Let&rsquo;s Encrypt</a>
<ul>
<li><a href="#org92c640a">sudo ufw allow 80,443/tcp</a></li>
<li><a href="#org6eada8d">sudo nextcloud.enable-https lets-encrypt</a></li>
<li><a href="#orgb147d92">Please enter an email address (for urgent notices or key recovery):</a></li>
<li><a href="#org94c38fa">Please enter your domain name(s) (space-separated): example.com</a></li>
</ul>
</li>
<li><a href="#org0cd008a">Login to Nextcloud</a>
<ul>
<li><a href="#org132e7ee">Go to https://example.com</a></li>
<li><a href="#org2e67506">After logging in&#x2026;</a></li>
</ul>
</li>
<li><a href="#orgcd428a0">Firewall</a>
<ul>
<li><a href="#org183f0a6">sudo apt install ufw</a></li>
<li><a href="#org65d3fd3">sudo vim /etc/default/ufw</a></li>
<li><a href="#orgec7fd1b">sudo ufw allow ssh   OR   sudo ufw allow 22</a></li>
<li><a href="#org5f8f977">sudo ufw enable</a>
<ul>
<li><a href="#orgf403957">Footer</a></li>
</ul>
</li>
</ul>
</li>
</ul>
</li>
</ul>
</div>
</div>
<table border="2" cellspacing="0" cellpadding="6" rules="groups" frame="hsides">


<colgroup>
<col  class="org-left" />

<col  class="org-left" />

<col  class="org-left" />

<col  class="org-left" />

<col  class="org-left" />

<col  class="org-left" />
</colgroup>
<tbody>
<tr>
<td class="org-left"><a href="../index.html">Home</a></td>
<td class="org-left"><a href="../dtos/index.html">DTOS</a></td>
<td class="org-left"><a href="index.html">Knowledge Base</a></td>
<td class="org-left"><a href="../community/index.html">Community</a></td>
<td class="org-left"><a href="../contribute/index.html">Contribute</a></td>
<td class="org-left"><a href="../support/index.html">Support DT&rsquo;s Work</a></td>
</tr>
</tbody>
</table>

<div id="outline-container-org17e9549" class="outline-2">
<h2 id="org17e9549">Installing Nextcloud on DigitalOcean Ubuntu Server</h2>
<div class="outline-text-2" id="text-org17e9549">
</div>
<div id="outline-container-org48b3ce3" class="outline-3">
<h3 id="org48b3ce3">Prerequisites</h3>
<div class="outline-text-3" id="text-org48b3ce3">
<p>
In order to complete the steps in this guide, you will need the following:
</p>
</div>
<div id="outline-container-org7b56951" class="outline-4">
<h4 id="org7b56951">A DigitalOcean droplet with Ubuntu Server 20.04.  Basic plan is fine for me.</h4>
</div>
<div id="outline-container-orga61df57" class="outline-4">
<h4 id="orga61df57">Be sure to update the server: <code>sudo apt update &amp;&amp; sudo apt upgrade</code></h4>
</div>
<div id="outline-container-org8e05843" class="outline-4">
<h4 id="org8e05843">A non-root sudo-enabled user and firewall configured on your server.</h4>
<div class="outline-text-4" id="text-org8e05843">
<ul class="org-ul">
<li>Add a user on Ubuntu: <code>adduser name</code></li>
<li>Add user to sudo group: <code>usermod -aG sudo name</code></li>
</ul>
</div>
</div>
<div id="outline-container-orgead862f" class="outline-4">
<h4 id="orgead862f">A domain name pointed to your server.</h4>
</div>
</div>
<div id="outline-container-org1be6bfd" class="outline-3">
<h3 id="org1be6bfd">Installing Nextcloud</h3>
<div class="outline-text-3" id="text-org1be6bfd">
</div>
<div id="outline-container-orgda7f245" class="outline-4">
<h4 id="orgda7f245">sudo snap install nextcloud</h4>
<div class="outline-text-4" id="text-orgda7f245">
<p>
The Nextcloud package will be downloaded and installed on your server.
</p>
</div>
</div>
<div id="outline-container-org35a756d" class="outline-4">
<h4 id="org35a756d">snap changes nextcloud</h4>
<div class="outline-text-4" id="text-org35a756d">
<p>
To verify it&rsquo;s installed.
</p>
</div>
</div>
</div>
<div id="outline-container-orgb587b9c" class="outline-3">
<h3 id="orgb587b9c">Configure Administrative Account</h3>
<div class="outline-text-3" id="text-orgb587b9c">
</div>
<div id="outline-container-org80db65a" class="outline-4">
<h4 id="org80db65a">sudo nextcloud.manual-install name password</h4>
<div class="outline-text-4" id="text-org80db65a">
<p>
This make a take a few minutes.  If successful you should get the output: Nextcloud was successfully installed
</p>
</div>
</div>
</div>
<div id="outline-container-org07d88ad" class="outline-3">
<h3 id="org07d88ad">Adjusting The Trusted Domains</h3>
<div class="outline-text-3" id="text-org07d88ad">
</div>
<div id="outline-container-orgf1f1094" class="outline-4">
<h4 id="orgf1f1094">sudo nextcloud.occ config:system:get trusted_domains</h4>
<div class="outline-text-4" id="text-orgf1f1094">
<p>
View the trusted_domains array.  At first, the only trusted domain is localhost.
</p>
</div>
</div>
<div id="outline-container-org6de770b" class="outline-4">
<h4 id="org6de770b">sudo nextcloud.occ config:system:set trusted_domains 1 &#x2013;value=example.com</h4>
<div class="outline-text-4" id="text-org6de770b">
<ul class="org-ul">
<li>Adds an entry for our domain.</li>
<li>To verify, again run: <code>sudo nextcloud.occ config:system:get trusted_domains</code></li>
</ul>
</div>
</div>
</div>
<div id="outline-container-orgca0fe87" class="outline-3">
<h3 id="orgca0fe87">SSL and Let&rsquo;s Encrypt</h3>
<div class="outline-text-3" id="text-orgca0fe87">
</div>
<div id="outline-container-org92c640a" class="outline-4">
<h4 id="org92c640a">sudo ufw allow 80,443/tcp</h4>
<div class="outline-text-4" id="text-org92c640a">
<p>
Opens the ports in the firewall that Let’s Encrypt uses to validate domain ownership.
</p>
</div>
</div>
<div id="outline-container-org6eada8d" class="outline-4">
<h4 id="org6eada8d">sudo nextcloud.enable-https lets-encrypt</h4>
<div class="outline-text-4" id="text-org6eada8d">
<p>
Requests a Let&rsquo;s Encrypt certificate.  You will be asked if your server meets the conditions necessary to request a certificate.  Answer &ldquo;y&rdquo;.
</p>
</div>
</div>
<div id="outline-container-orgb147d92" class="outline-4">
<h4 id="orgb147d92">Please enter an email address (for urgent notices or key recovery):</h4>
</div>
<div id="outline-container-org94c38fa" class="outline-4">
<h4 id="org94c38fa">Please enter your domain name(s) (space-separated): example.com</h4>
</div>
</div>
<div id="outline-container-org0cd008a" class="outline-3">
<h3 id="org0cd008a">Login to Nextcloud</h3>
<div class="outline-text-3" id="text-org0cd008a">
</div>
<div id="outline-container-org132e7ee" class="outline-4">
<h4 id="org132e7ee">Go to <a href="https://example.com">https://example.com</a></h4>
<div class="outline-text-4" id="text-org132e7ee">
<p>
Since you have already configure an administrator account from the command line, you will be taken to the Nextcloud login page.
</p>
</div>
</div>
<div id="outline-container-org2e67506" class="outline-4">
<h4 id="org2e67506">After logging in&#x2026;</h4>
<div class="outline-text-4" id="text-org2e67506">
<p>
The first time you enter, a window will be displayed with some introductory text and links to various Nextcloud clients that can be used to access your Nextcloud instance.
</p>
</div>
</div>
</div>
<div id="outline-container-orgcd428a0" class="outline-3">
<h3 id="orgcd428a0">Firewall</h3>
<div class="outline-text-3" id="text-orgcd428a0">
</div>
<div id="outline-container-org183f0a6" class="outline-4">
<h4 id="org183f0a6">sudo apt install ufw</h4>
</div>
<div id="outline-container-org65d3fd3" class="outline-4">
<h4 id="org65d3fd3">sudo vim /etc/default/ufw</h4>
<div class="outline-text-4" id="text-org65d3fd3">
<p>
Ubuntu server has IPv6 enabled, ensure that UFW is configured to support IPv6 so that it will manage firewall rules for IPv6 in addition to IPv4. Set: IPV6=yes
</p>
</div>
</div>
<div id="outline-container-orgec7fd1b" class="outline-4">
<h4 id="orgec7fd1b">sudo ufw allow ssh   OR   sudo ufw allow 22</h4>
</div>
<div id="outline-container-org5f8f977" class="outline-4">
<h4 id="org5f8f977">sudo ufw enable</h4>
<div class="outline-text-4" id="text-org5f8f977">
</div>

<div id="outline-container-orgf403957" class="outline-5">
<h5 id="orgf403957">Footer</h5>
<div class="outline-text-5" id="text-orgf403957">
<p>
Copyright © 2020-2021 Derek Taylor (DistroTube)
</p>

<p>
This page is licensed under a <a href="https://creativecommons.org/licenses/by-nd/4.0/">Creative Commons Attribution-NoDerivatives 4.0 International License</a> (CC-BY-ND 4.0).
</p>

<p>
The source code for distro.tube can be found on <a href="https://gitlab.com/dwt1/distro.tube">GitLab</a>.  User-submitted contributions to the site are welcome, as long as the contributor agrees to license their submission with the CC-BY-ND 4.0 license.
</p>
</div>
</div>
</div>
</div>
</div>
</div>
<div id="postamble" class="status">
<p class="author">Author: dt</p>
<p class="date">Created: 2021-12-03 Fri 15:43</p>
</div>
</body>
</html>
